//Character Power-Ups/Abilities/Etc. Scripts

//New Power-Up Objects/Effects
freeslot(
"MT_POWERUP",
"MT_POWERUPNOTIFICATION",
"MT_POWERUPARROW",
"S_POWERUP_SPAWN",
"S_POWERUP_CHASE",
"S_PUPNO_SPAWN",
"S_PUPNO_CHASE",
"S_PUPNO_FADEOUT",
"S_PUPARROW_SPAWN",
"S_PUPARROW_CHASE",
"S_PUPARROW_FADEOUT",
"SPR_PWUP",
"SPR_PWNO",
"SPR_PARW"
)

mobjinfo[MT_POWERUP] = {
	doomednum = -1,
	spawnstate = S_POWERUP_SPAWN,
	spawnhealth = 1,
	deathstate = S_SPRK1,
	speed = 1,
	radius = 18*FRACUNIT,
	height = 45*FRACUNIT,
	flags = MF_NOGRAVITY
}
mobjinfo[MT_POWERUPNOTIFICATION] = {
	doomednum = -1,
	spawnstate = S_PUPNO_SPAWN,
	spawnhealth = 1,
	deathstate = S_NULL,
	seestate = S_PUPNO_CHASE,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}
mobjinfo[MT_POWERUPARROW] = {
	doomednum = -1,
	spawnstate = S_PUPARROW_SPAWN,
	spawnhealth = 1,
	deathstate = S_NULL,
	seestate = S_PUPARROW_CHASE,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_RUNSPAWNFUNC
}

//Power-Up States
states[S_POWERUP_SPAWN] = {SPR_PWUP, A, 25, nil, 0, 0, S_POWERUP_CHASE}
states[S_POWERUP_CHASE] = {SPR_PWUP, A, 1, A_HomingChase, 40*FRACUNIT, 0, S_POWERUP_CHASE}

//Power-Up Notification States
states[S_PUPNO_SPAWN] = {SPR_PWNO, A, 1, A_FadeEffect, 0, 0, S_PUPNO_SPAWN}
states[S_PUPNO_CHASE] = {SPR_PWNO, FF_ANIMATE|B, 105, nil, 6, 3, S_PUPNO_FADEOUT}
states[S_PUPNO_FADEOUT] = {SPR_PWNO, A, 1, A_FadeEffect, 1, 3, S_PUPNO_FADEOUT}

//Power-Up Arrow States
states[S_PUPARROW_SPAWN] = {SPR_PARW, A, 1, A_FadeEffect, 0, 0, S_PUPARROW_SPAWN}
states[S_PUPARROW_CHASE] = {SPR_PARW, B, 105, nil, 0, 0, S_PUPARROW_FADEOUT}
states[S_PUPARROW_FADEOUT] = {SPR_PARW, A, 1, A_FadeEffect, 1, 3, S_PUPARROW_FADEOUT}

//Reset Power-Up Counter & Kill Count
local function PowerCounterReset(player)
	player.spc = 0
	player.kpc = 0
	player.mo.skc = 0
	player.mo.kkc = 0
end
addHook("PlayerSpawn", PowerCounterReset)

//Power-Up Thinker
addHook("MobjThinker", function(pup)
	if not (pup.dead)
		if pup.timer == nil
			pup.timer = 0
		else
			pup.timer = $+1
			
			//Sparkle thing that follows the object
			if leveltime % 32 == 0
				pup.sparkle = P_SpawnMobj(pup.x, pup.y, pup.z, MT_IVSP)
			end
			if pup.sparkle and pup.sparkle.valid
				local sparkle = pup.sparkle
				sparkle.scale = 2*FRACUNIT
				sparkle.target = pup
				sparkle.info.dispoffset = 1
				if sparkle.target and sparkle.target.valid
					P_TeleportMove(sparkle, pup.x+pup.momx,
					pup.y+pup.momy, pup.z+pup.momz)
				end
			end
			
			if pup.timer == 25
				pup.flags = $1^^MF_SPECIAL
			
			//After 6 sec. start flickering
			elseif pup.timer > 6*TICRATE and pup.timer < 7*TICRATE
				if leveltime % 2 == 0
					pup.flags2 = $^^MF2_DONTDRAW
				end
			//Faster flickering effect after 7 sec.
			elseif pup.timer > 7*TICRATE and pup.timer < 8*TICRATE
				pup.flags2 = $^^MF2_DONTDRAW
			elseif pup.timer > 8*TICRATE -- If more than 8 sec. have passed, remove mobj
				P_KillMobj(pup, pup, pup)
				pup.dead = true
			end
		end
	else
		if pup.sparkle and pup.sparkle.valid
			pup.sparkle = S_NULL
		end
	end
	
	//Make the power-up's frame match (during chase state) 
	if pup.target.rewardsonic
		states[S_POWERUP_CHASE].frame = A
	elseif pup.target.rewardknuckles
		states[S_POWERUP_CHASE].frame = B
	end
end, MT_POWERUP)

//Power-Up interaction
local function PowerUp(pup, mo)
	if mo.skin == "sonic" or mo.skin == "knuckles"
		local player = mo.player -- For the HUD related stuff
		S_StartSound(mo, sfx_ncitem, player)
		
		//Character's power-up counter handling
		if mo.rewardsonic
			if player.spc < 2
				player.spc = $+1
				//Spawn power-up notification for Sonic
				mo.pun = P_SpawnMobj(mo.x, mo.y, mo.z, MT_POWERUPNOTIFICATION)
				mo.pun.target = mo
				mo.pun.color = 55
			else
				P_AddPlayerScore(player, 500)
				local score = P_SpawnMobj(mo.x, mo.y, mo.z+32*FRACUNIT, MT_SCORE)
				score.frame = C
			end
		elseif mo.rewardknuckles
			if player.kpc < 2
				player.kpc = $+1
				//Spawn power-up notification for Sonic
				mo.pun = P_SpawnMobj(mo.x, mo.y, mo.z, MT_POWERUPNOTIFICATION)
				mo.pun.target = mo
				mo.pun.color = 23
			else
				P_AddPlayerScore(player, 500)
				local score = P_SpawnMobj(mo.x, mo.y, mo.z+32*FRACUNIT, MT_SCORE)
				score.frame = C
			end
		end
	end
end
addHook("TouchSpecial", PowerUp, MT_POWERUP)

//Power-Up Notification Thinker
addHook("MobjThinker", function(pun)
	local mo = pun.target
	local xpos = mo.x+FixedMul(36*FRACUNIT, cos(mo.angle+ANGLE_90))
	local ypos = mo.y+FixedMul(36*FRACUNIT, sin(mo.angle+ANGLE_90))
	local xposn = mo.x-FixedMul(-36*FRACUNIT, cos(mo.angle-ANGLE_90))
	local yposn = mo.y-FixedMul(-36*FRACUNIT, sin(mo.angle-ANGLE_90))
	
	//Keep notification bar above the player's head
	P_TeleportMove(pun, mo.x, mo.y, mo.z+64*FRACUNIT)
	
	//Spawn arrows effect
	if pun.timer == nil
		pun.timer = 0
	else
		pun.timer = $+1
	end
	if pun.timer == 1
		//First Arrow
		pun.arrow1 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_POWERUPARROW)
		pun.arrow1.scale = (FRACUNIT/2)*3
		pun.arrow1.target = mo
		pun.arrow1.color = pun.color
		
		//Second Arrow
		pun.arrow2 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_POWERUPARROW)
		pun.arrow2.scale = (FRACUNIT/2)*3
		pun.arrow2.target = mo
		pun.arrow2.color = pun.color
		
	elseif pun.timer > 1
		//Arrows stick to the player's sides
		P_TeleportMove(pun.arrow1, xpos, ypos, mo.z+24*FRACUNIT)	
		P_TeleportMove(pun.arrow2, xposn, yposn, mo.z+24*FRACUNIT)
		A_CustomFloat(pun.arrow1, 4, 2)
		A_CustomFloat(pun.arrow2, 2, 6)
	end
	if pun.arrow1 != nil and pun.arrow2 != nil
		if mo.eflags & MFE_VERTICALFLIP and not (pun.flipped)
			pun.flags2 = $^^MF2_OBJECTFLIP
			pun.arrow1.flags2 = $^^MF2_OBJECTFLIP
			pun.arrow2.flags2 = $^^MF2_OBJECTFLIP
			pun.flipped = true
		end
	end
end, MT_POWERUPNOTIFICATION)

//Kill Count Script:
/*MobjDeath hook is used to manage a kill count for Sonic and Knuckles.
Note: "skc" refers to Sonic's kill count, "kkc" refers to Knuckles' kill
count.*/

for i = 0, #mobjinfo-1 do
	if not (mobjinfo[i].flags & MF_ENEMY)
		continue
	end
	addHook("MobjDeath", function(mobj, inflictor, mo)
		if mo and mo.valid and inflictor and inflictor.valid
			local player = mo.player
			if not (player) return end -- Not killed by player?
			if mo.skin == "sonic" or mo.skin == "knuckles"

				if mo.homingattacked or mo.shotknuxmissile
					mo.specialattacked = true
				end
				
				//Award the character that kills an enemy with a point
				if inflictor != nil and inflictor.type == MT_GHOST
					inflictor.target = mo
					mo.skc = $+1
					inflictor.fuse = 4
				else
					if mo.skin == "sonic"
					or mo.skin == "sonic" and inflictor.type == MT_SPINFIRE
						mo.skc = $+1
					elseif mo.skin == "knuckles"
					or mo.skin == "knuckles" and inflictor.type == MT_SPINFIRE
						mo.kkc = $+1
					end
				end
				
				/*If the total kill count between Sonic and Knuckles == 5 then reward
				the character that killed more enemies.*/
				if mo.skc + mo.kkc == 5 -- Total kill count == 5?
					if mo.pup and mo.pup.valid -- Erase previously existing power-up
						mo.pup.state = S_NULL
					end
					mo.pup = P_SpawnMobj(mo.x, mo.y, mo.z, MT_POWERUP)
					mo.pup.target = mo
					if mo.skc > mo.kkc
						mo.rewardsonic = true
						mo.rewardknuckles = false
						mo.pup.frame = TR_TRANS50|A
					elseif mo.kkc > mo.skc
						mo.rewardknuckles = true
						mo.rewardsonic = false
						mo.pup.frame = TR_TRANS50|B
					end
					mo.skc = 0
					mo.kkc = 0
				end
			end
		end
	end, i)
end